<script>
    import { useQuery } from "@sveltestack/svelte-query";
    import { fetch_json } from "../fetch_json.js";
    import { Select, Helper, Label } from "flowbite-svelte";
    import { layout } from "../svelte_stores/layout_store";
    import { set_dataset_parameters } from "../svelte_stores/catalog_and_info_store.js";

    export let i_subplot;
    export let i_plot_element;
    // export let info_query;
    export let parameter_type;
    export let placeholder;
    export let allowed_types;

    // Set parameter info based on info query
    let parameter_info = {};

    let subplot, plot_element, server, dataset, info_url, parameter_name;
    $: {
        if ($layout.subplots[i_subplot]) {
            subplot = $layout.subplots[i_subplot];
            if ($layout.subplots[i_subplot].plot_elements[i_plot_element]) {
                plot_element = subplot.plot_elements[i_plot_element];
                server = plot_element.data.server;
                dataset = plot_element.data.dataset;
                info_url = server + "/info?id=" + dataset;
                parameter_name = plot_element.data[parameter_type];
            }
        }
    }

    $: info_query = useQuery(["info", info_url], fetch_json, {
        staleTime: 86400e3,
    });

    $: {
        if ($info_query.isSuccess && typeof parameter_name != "undefined") {
            parameter_info = $info_query.data.parameters.filter((par) => {
                return par.name == parameter_name;
            })[0];
        }
    }

    // Key to the component id, used for vector or binned parameters only
    $: component_index_name = parameter_type + "_component_index";
</script>

{#if subplot && plot_element && $info_query.isSuccess}
    <Select
        {placeholder}
        bind:value={plot_element.data[parameter_type]}
        on:change={() => {
            $layout = set_dataset_parameters($layout);
        }}>
        {#each $info_query.data.parameters as parameter}
            {#if parameter.name == parameter_name}
                <option value={parameter.name} selected
                    >{parameter.name}</option>
            {:else}
                <!-- Check for parameter data type -->
                {#if allowed_types.includes(parameter.type)}
                    <option value={parameter.name}>{parameter.name}</option>
                {:else}
                    <option value={parameter.name} disabled
                        >{parameter.name} ({parameter.type})</option>
                {/if}
            {/if}
        {/each}
    </Select>

    <!-- Print the description below the select field, if available -->
    {#if typeof parameter_info !== "undefined"}
        {#if "description" in parameter_info}
            <Helper>{parameter_info["description"]}</Helper>
        {:else}
            <Helper>No parameter description available in dataset info.</Helper>
        {/if}

        <!-- Optionally, select a bin or coordinate -->
        {#if "size" in parameter_info}
            {#if parameter_info.size.length != 1}
                Only parameters that are a scalar or are one-dimensional
                (vectors / bins) are supported

                <!-- Vector components  -->
            {:else if "vectorComponents" in parameter_info}
                <Label
                    >Vector component:
                    <Select
                        placeholder="Select a component..."
                        bind:value={plot_element.data[component_index_name]}>
                        {#each parameter_info.vectorComponents as component, i_component}
                            <option value={i_component}
                                >{parameter_info.label[i_component]}</option>
                        {/each}
                    </Select>
                </Label>

                <!-- Bin -->
            {:else if "bins" in parameter_info}
                {#if "centers" in parameter_info["bins"][0]}
                    <Label
                        >Bin center:
                        <Select
                            placeholder="Select a bin..."
                            bind:value={$layout.subplots[i_subplot]
                                .plot_elements[i_plot_element].data[
                                component_index_name
                            ]}>
                            {#each parameter_info["bins"][0]["centers"] as bincenter, i_bincenter}
                                <option value={i_bincenter}>
                                    {bincenter}
                                    {parameter_info["bins"][0]["units"]}
                                </option>
                            {/each}
                        </Select>
                    </Label>
                {:else if "ranges" in parameter_info["bins"][0]}
                    <Label
                        >Bin range:
                        <Select
                            placeholder="Select a bin..."
                            bind:value={$layout.subplots[i_subplot]
                                .plot_elements[i_plot_element].data[
                                component_index_name
                            ]}>
                            {#each parameter_info["bins"][0]["ranges"] as binrange, i_binrange}
                                <option value={i_binrange}>
                                    {binrange.join(" - ")}
                                    {parameter_info["bins"][0]["units"]}
                                </option>
                            {/each}
                        </Select>
                    </Label>
                {/if}

                <!-- Unidentified components (bin or vector?) -->
            {:else}
                <Label
                    >Component or bin:
                    <Select
                        placeholder="Select a component or bin..."
                        bind:value={$layout.subplots[i_subplot].plot_elements[
                            i_plot_element
                        ].data[component_index_name]}>
                        {#each [...Array(parameter_info.size[0]).keys()] as i_component}
                            <option value={i_component}>{i_component}</option>
                        {/each}
                    </Select>
                </Label>
            {/if}
        {/if}
    {/if}
{/if}

<style>
</style>
